#define STREIK_BEI_SUESSWARENMANGEL     ' auskommentieren, wenn die Arbeiter desertieren sollen

#if defined(__FB_PCOS__)
  #define slash "\"
#elseif defined(__FB_UNIX__)
  #define slash "/"
#endif

#include once "vbcompat.bi"
#include once "fbgfx.bi"

namespace SET
  const HexGroesse        = 30              ' Hoehe eines Hex
  const HexRadius         = 16              ' HexRadius = HexGroesse / sqrt(3)
  const HexXplus          = Hexgroesse\2    ' Verschiebung der linken oberen Ecke
  const HexYplus          = -HexGroesse\2   '     relativ zum Mittelpunkt
  const FeldBreit         = 25              ' Breite des Spielfeldes in Hex
  const FeldHoch          = 18              ' Hoehe des Spielfeldes in Hex
  const FeldXPlus         = 200             ' Breite des linken Randes
  const Fensterbreite     = (FeldBreit+2)*HexRadius*3/2+HexXplus+FeldXplus
  const Fensterhoehe      = (FeldHoch+2)*HexGroesse+HexYplus

  const InfoX             = 20              ' Position der Informationsleiste
  const InfoY             = 300
  const InfoHoch          = 250
  const SteuerX           = 20              ' Position der Steuerleiste
  const SteuerY           = 20
  const SteuerBreit       = 180
  const SteuerHoch        = 250
  const SteuerFeld        = 0
  const SteuerFalleProd   = 30
  const SteuerJaeger      = 60
  const SteuerMine        = 0
  const SteuerGarten      = 0
  const SteuerKrieger     = 30
  const SteuerFalleSetz   = 90
  
  const KostenArbeiter    = 50
  const KostenKrieger     = 30
  const KostenFalle       = 20
  const KostenFeld1       = 10
  const KostenFeld2       = 10
  const Jagdbeute         = 20

  const Schrittezahl      = 10              ' Einzelschritte von Hex zu Hex
  const MaxFeldarbeiter   = 9               ' maximale Anzahl der Arbeiter/Krieger
  const MaxMinenarbeiter  = 99
  const MaxJaeger         = 99
  const MaxKrieger        = 99
  const MaxAnzeigen       = 6

  const MinenFaktor       = 1000
  const MinenFuellung     = 200             ' Fuellmenge einer normalen Mine
  const MinenRegeneration = 10              ' Erholungsgeschwindigkeit in Tausendstel/Zeiteinheit

  const FarbeHex          = &h555555        ' Farbe Hex-Umrandung
  const FarbeSpieler      = &h3333ff        ' Farbe der Hex des Spielers (Haus, Garten)
  const FarbeMitspieler   = &h33ff33        ' Farbe befreundeter Spieler
  const FarbeGegner       = &hff3333        ' Farbe gegnerischer Spieler
  const FarbeMark         = &hbbbb00        ' Farbe eines markierten Hex
  dim as uinteger FarbeFigur(9, 1) = _
         { { &h0000ff, &h000077 }, { &hff0000, &h770000 }, { &h00ff00, &h007700 }, { &h00ffff, &h007777 },_
           { &hffff00, &h777700 }, { &h0000ff, &h000077 }, { &h0000ff, &h000077 }, _
           { &h0000ff, &h000077 }, { &h0000ff, &h000077 }, { &h0000ff, &h000077 } }
  const Wartezeit         = .05             ' Spielverzoegerung zwischen den Einzelschritten
end namespace

#define ae !"\132" '
#define oe !"\148" '
#define ue !"\129" '
#define ss !"\225" '

enum Arbeiterwert explicit
  Daheim = 1, LaufHeim, LaufJagen, LaufPflanzen, LaufErnten = 22, LaufBeute = 40
end enum

enum Button explicit
  Leer = 0, Feld, Jaeger, FalleProd, FalleSetz, Mine, Krieger, Garten
end enum
enum Feldart explicit
  Leer = 0, Haus, Mine
  Garten0, Garten1, Garten2, Garten3, Garten4, Garten5
  ' ACHTUNG: DefektXX sind immer die letzten Eintraege!
  Defekt10, Defekt20, Defekt30, Defekt40, Defekt50, Defekt60, Defekt70, Defekt80, Defekt90, Defekt100
end enum
enum Figurart explicit
  Leer = 0, Feld, Mine, Jaeger, Krieger
end enum
enum Modus explicit
  Leer = 0, Haus, Fremd, Mine, Feld, Arbeiter = 16, Krieger = 32, Einzug = 64
end enum

type TypOption
  as string bezeichnung
  as integer wert
  declare constructor
  declare constructor(b as string, w as integer = 0)
end type
constructor TypOption
end constructor
constructor TypOption(b as string, w as integer = 0)
  this.bezeichnung = b
  this.wert = w
end constructor
operator =(o1 as TypOption, o2 as TypOption) as integer
  return iif(o1.bezeichnung = o2.bezeichnung, -1, 0)
end operator

type TypAnzeige
  as string typ, text
  as integer nr
  declare constructor
  declare constructor(typ as string, text as string, nr as integer = -1)
end type
constructor TypAnzeige
  this.nr = -1
end constructor
constructor TypAnzeige(typ as string, text as string, nr as integer = -1)
  this.typ  = typ
  this.text = text
  this.nr   = nr
end constructor

type TypFeld
  as Feldart art
  as integer besitzer, fuellMax, fuellAktuell, regeneration
end type

type TypFigur
  as integer x, y, neuX, neuY, zielX, zielY, arbeitX, arbeitY, warte, wert, gegner
  as FB.Image ptr img
  declare constructor
  declare constructor(bild as FB.Image ptr, x as integer, y as integer, zx as integer = -1, zy as integer = -1, g as integer = 0)
  declare sub weiter
end type
constructor TypFigur
end constructor
constructor TypFigur(bild as FB.Image ptr, x as integer, y as integer, zx as integer = -1, zy as integer = -1, g as integer = 0)
  with this
    .neux    = x
    .neuy    = y
    .zielX   = iif(zx < 0, x, zx)
    .zielY   = iif(zy < 0, y, zy)
    .arbeitX = .zielX
    .arbeitY = .zielY
    .gegner  = g
    .img     = bild
    .wert    = Arbeiterwert.Daheim
    .weiter
  end with
end constructor
operator =(f1 as TypFigur, f2 as TypFigur) as integer
  if f1.x = f2.x and f1.y = f2.y then return -1 else return 0
end operator

type TypGarten
  as integer wert, x, y
end type

type TypOrt
  as integer x, y
end type

#include once "Lua/lua.bi"
#include once "Lua/lauxlib.bi"
#include once "inc/mdList.bi"
mdListDeclare(TypFigur)
mdListDeclare(TypOption)

type TypSpielopt
  as integer typ, fuellGesamt, dollar, suess, beute, schaden
  as integer fallen, fallenprod
  as integer inaktivFeld, inaktivFeldarb, inaktivMinen, inaktivJaeger, inaktivKrieger, inaktivFalle
  as mdList(TypFigur) feldarbeiter, minenarbeiter, jaeger, krieger
  as TypGarten garten(1 to 18)
  as integer anzArbeiter, anzFeldarbeiter, anzMinenarbeiter, anzJaeger
  as integer anzGarten, anzKrieger, hausX, hausY, markX, markY
  as FB.Image ptr img(1)
  declare destructor
  declare sub gartenBerechnen
  declare sub add(typ as Figurart, x as integer, y as integer, _
                  zx as integer = -1, zy as integer = -1)
  declare property opt(bez as string, wert as integer)
  declare property opt(bez as string) as integer
  private:
  as mdList(TypOption) optionen
end type
destructor TypSpielopt
  if this.img(0) > 0 then imagedestroy this.img(0) : this.img(0) = 0
  if this.img(1) > 0 then imagedestroy this.img(1) : this.img(1) = 0
end destructor
property TypSpielopt.opt(bez as string, wert as integer)
  dim as TypOption temp = TypOption(lcase(bez), wert)
  select case bez
    case "fuellgesamt"          : this.fuellGesamt    = wert
    case "dollar"               : this.dollar         = wert
    case "suess"                : this.suess          = wert
    case "beute"                : this.beute          = wert
    case "schaden"              : this.schaden        = wert
    case "fallen"               : this.fallen         = wert
    case "fallenproduktion"     : this.fallenprod     = wert
    case "inaktivfeld"          : this.inaktivFeld    = wert
    case "inaktivfeldarbeiter"  : this.inaktivFeldarb = wert
    case "inaktivminenarbeiter" : this.inaktivMinen   = wert
    case "inaktivjaeger"        : this.inaktivJaeger  = wert
    case "inaktivkrieger"       : this.inaktivKrieger = wert
    case "inaktivfalle"         : this.inaktivFalle   = wert
    case else
      with this.optionen
        if .contains(temp) then
          temp = .set(.indexof(temp), temp)
        else
          .add(temp)
        end if
      end with
  end select
end property
property TypSpielopt.opt(bez as string) as integer
  dim as TypOption temp = TypOption(lcase(bez))
  select case lcase(bez)
    case "kostenarbeiter"       : return SET.KostenArbeiter
    case "kostenkrieger"        : return SET.KostenKrieger
    case "kostenfalle"          : return SET.KostenFalle
    case "kostenfeld1"          : return SET.KostenFeld1
    case "kostenfeld2"          : return SET.KostenFeld2
    case "schrittezahl"         : return SET.Schrittezahl
    case "maxfeldarbeiter"      : return SET.MaxFeldarbeiter
    case "maxminenarbeiter"     : return SET.MaxMinenarbeiter
    case "maxjaeger"            : return SET.MaxJaeger
    case "maxkrieger"           : return SET.MaxKrieger
    case "fuellgesamt"          : return this.fuellGesamt
    case "dollar"               : return this.dollar
    case "suess"                : return this.suess
    case "beute"                : return this.beute
    case "schaden"              : return this.schaden
    case "fallen"               : return this.fallen
    case "fallenproduktion"     : return this.fallenprod
    case "inaktivfeld"          : return this.inaktivFeld
    case "inaktivfeldarbeiter"  : return this.inaktivFeldarb
    case "inaktivminenarbeiter" : return this.inaktivMinen
    case "inaktivjaeger"        : return this.inaktivJaeger
    case "inaktivkrieger"       : return this.inaktivKrieger
    case "inaktivfalle"         : return this.inaktivFalle
    case "anzarbeiter"          : return this.anzArbeiter
    case "anzfeldarbeiter"      : return this.anzFeldarbeiter
    case "anzminenarbeiter"     : return this.anzMinenarbeiter
    case "anzjaeger"            : return this.anzJaeger
    case "anzkrieger"           : return this.anzKrieger
    case "anzgarten"            : return this.anzGarten
    'case "Garten"
    '  temp = (spieloptionen+nr)->garten(p(0)).wert
    '  (spieloptionen+nr)->garten(p(0)).wert = p(1)
    '  if temp = 0 and p(1) > 0 then (spieloptionen+nr)->anzGarten += 1
    '  if temp > 0 and p(1) = 0 then (spieloptionen+nr)->anzGarten -= 1
    case else
      with this.optionen
        if .contains(temp) then return .get(.indexof(temp)).wert
      end with
  end select
  return -1
end property

declare sub bewegen(spieler() as TypSpielopt)
declare sub hexfeld overload (fx as integer, fy as integer, farbe as integer)
declare sub hexfeld(fx as integer, fy as integer, f as TypFeld)
declare sub info(opt() as TypSpielopt, spielernr as integer)
declare function pruefeButtons(opt as TypSpielopt, anzeige as integer = 0) as integer
declare function rechtsbuendig overload (s as string, anz as integer) as string
declare function rechtsbuendig(i as integer, anz as integer) as string
declare sub steuerleiste(opt as TypSpielopt, anzeige as integer = 0)
declare sub zeichne overload (opt as TypSpielopt, schrittweite as integer)
declare sub zeichne(liste as mdList(TypFigur), schritt as integer)

declare function leseOpt cdecl (byval lua AS lua_State ptr) as long
declare function setzeInfo cdecl (byval L as lua_State ptr) as long
declare sub setzeOpt cdecl (byval lua AS lua_State ptr)

' Lua
function lua_Alloc cdecl (byval ud as any ptr, byval p as any ptr, byval osize as uinteger, _
                                     byval nsize as uinteger) as any ptr
  if nsize = 0 then
    deallocate p
    return NULL
  else
    return reallocate(p, nsize)
  end if
end function

dim shared Lua as lua_State ptr
Lua = lua_newstate(@lua_Alloc, NULL)
lua_register(Lua, "set", cast(any ptr, @setzeOpt))
lua_register(Lua, "get", cast(any ptr, @leseOpt))
lua_register(Lua, "info", cast(any ptr, @setzeInfo))

dim as TypSpielopt opt(9), gegner
dim shared as TypSpielopt ptr spieloptionen
spieloptionen = @opt(0)
dim shared as integer spielerzahl
dim as integer spielerMisch(9)

sub TypSpielopt.add(typ as Figurart, x as integer, y as integer, _
                    zx as integer = -1, zy as integer = -1)
  ' neuen Arbeiter o. ae. in der Liste einfuegen
  select case typ
    case Figurart.Feld
      if this.anzFeldarbeiter < SET.MaxFeldarbeiter then
        this.feldarbeiter.add TypFigur(this.img(int(rnd*2)), x, y)
        this.anzFeldarbeiter += 1
        this.anzArbeiter += 1
        this.suess -= SET.KostenArbeiter
      end if
    case Figurart.Mine
      if this.anzMinenarbeiter < SET.MaxMinenarbeiter then
        this.minenarbeiter.add TypFigur(this.img(int(rnd*2)), x, y, zx, zy)
        this.anzMinenarbeiter += 1
        this.anzArbeiter += 1
        this.suess -= SET.KostenArbeiter
      end if
    case Figurart.Jaeger
      if this.anzJaeger < SET.MaxJaeger then
        dim as integer gegner
        for gegner = 0 to spielerzahl-1
          if (spieloptionen+gegner)->hausX = zx and (spieloptionen+gegner)->hausY = zy then exit for
        next
        this.jaeger.add TypFigur(this.img(int(rnd*2)), x, y, zx, zy, gegner)
        this.anzJaeger += 1
        this.anzArbeiter += 1
        this.suess -= SET.KostenArbeiter
      end if
    case Figurart.Krieger
      if this.anzKrieger < SET.MaxKrieger then
        this.krieger.add TypFigur(this.img(int(rnd*2)), x, y)
        this.anzKrieger += 1
        this.dollar -= SET.KostenKrieger
      end if
  end select
end sub

sub TypFigur.weiter
  with this
    .x = .neuX
    .y = .neuY
    if .warte > 0 then
      .warte -=1                                                  ' Wartezeit absitzen
      exit sub
    end if
    if .x = .zielX then
      if .y = .zielY then
        exit sub                                                  ' Ziel schon erreicht
      else
        .neuY += sgn(.zielY - .y)                                 ' nur noch senkrecht laufen
        exit sub
      end if
    end if
    if .y = .zielY then .neuX += sgn(.zielX - .x) : exit sub      ' nur noch waagrecht laufen
    dim as integer dx = abs(.zielX-.x), dy = abs(.zielY-.y)
    if dx mod 2 then
      dx += iif((.x mod 2) = 0 xor zielY > .y, 1, -1)
    end if
    if dx < 2*dy then
      .neuY += sgn(.zielY - .y)
    else
      .neuX += sgn(.zielX - .x)
      if dx = 2*dy andalso ((.x mod 2) = 1) xor (.y > .zielY) then .neuY += sgn(zielY - .y)
    end if
  end with
end sub

sub TypSpielopt.gartenBerechnen
  with this
    .anzGarten = 0
    for i as integer = 1 to 18
      select case as const i
        case 15 to 17     : .garten(i).x = .hausX - 2
        case 5, 6, 14, 18 : .garten(i).x = .hausX - 1
        case 1, 4, 7, 13  : .garten(i).x = .hausX
        case 2, 3, 8, 12  : .garten(i).x = .hausX + 1
        case else         : .garten(i).x = .hausX + 2
      end select
      select case as const i
        case 7            : .garten(i).y = .hausY - 2
        case 1, 9, 17     : .garten(i).y = .hausY - 1
        case 10, 16       : .garten(i).y = .hausY
        case 4, 11, 15    : .garten(i).y = .hausY + 1
        case 13           : .garten(i).y = .hausY + 2
        case 2, 3         : .garten(i).y = .hausY - 3 + i + (.hausX mod 2)
        case 5, 6         : .garten(i).y = .hausY + 5 - i + (.hausX mod 2)
        case 8, 18        : .garten(i).y = .hausY - 2 - (.hausX mod 2)
        case 12, 14       : .garten(i).y = .hausY + 1 - (.hausX mod 2)
      end select
      if .garten(i).wert > 0 then .anzGarten += 1
    next
  end with
end sub

dim shared as TypFeld feld(SET.FeldBreit, SET.FeldHoch)
dim shared as TypOrt minen()
dim shared as TypAnzeige anzeige()
dim shared as FB.IMAGE ptr img(Feldart.Defekt100), hintergrund

sub ende destructor
  ' aufraeumen am Ende des Prgramms
  for i as integer = 1 to ubound(img)
    imagedestroy img(i)
  next
  imagedestroy hintergrund
  lua_close Lua
end sub

sub bewegen(spieler() as TypSpielopt)
  dim as TypFigur arbeiter
  dim as integer x, y
  for s as integer = 0 to ubound(spieler)
    spieler(s).suess -= spieler(s).anzArbeiter
    ' Feldarbeiter bewegen
    for i as integer = 0 to spieler(s).feldarbeiter.size - 1
      arbeiter = spieler(s).feldarbeiter.get(i)
      with arbeiter
        select case .wert
          case 0 : continue for
          case Arbeiterwert.Daheim
            if spieler(s).schaden > 0 then
              spieler(s).schaden -= 1
              exit select
            end if
            for g as integer = 1 to 18
              if spieler(s).garten(g).wert = 1 then             ' Garten zum Bepflanzen
                spieler(s).garten(g).wert = 2
                .zielX = spieler(s).garten(g).x
                .zielY = spieler(s).garten(g).y
                .wert = Arbeiterwert.LaufPflanzen + g-1
                exit select
              end if
            next
            for g as integer = 1 to 18
              if spieler(s).garten(g).wert = 22 then            ' Garten zum Ernten
                spieler(s).garten(g).wert = 23
                .zielX = spieler(s).garten(g).x
                .zielY = spieler(s).garten(g).y
                .wert = Arbeiterwert.LaufErnten + g-1
                exit for
              end if
            next
          case Arbeiterwert.LaufPflanzen to Arbeiterwert.LaufPflanzen+17
            if .x = .zielX and .y = .zielY then
              .warte = 0
              .zielX = spieler(s).hausX
              .zielY = spieler(s).hausY
              spieler(s).garten(.wert-Arbeiterwert.LaufPflanzen+1).wert = 3
              .wert = Arbeiterwert.LaufHeim
            end if
          case Arbeiterwert.LaufErnten to Arbeiterwert.LaufErnten+17
            if .x = .zielX and .y = .zielY then
              .warte = 0
              .zielX = spieler(s).hausX
              .zielY = spieler(s).hausY
              spieler(s).garten(.wert-Arbeiterwert.LaufErnten+1).wert = 1
              .wert = Arbeiterwert.LaufHeim
              spieler(s).suess += 50
            end if
          case Arbeiterwert.LaufHeim
            if .x = .zielX and .y = .zielY then
              .warte = 1
              .wert  = Arbeiterwert.Daheim
            end if            
        end select
        .weiter
        arbeiter = spieler(s).feldarbeiter.set(i, arbeiter)
      end with
    next
    ' Minenarbeiter bewegen
    for i as integer = 0 to spieler(s).minenarbeiter.size - 1
      arbeiter = spieler(s).minenarbeiter.get(i)
      with arbeiter
        select case .wert
          case 0 : continue for
          case Arbeiterwert.Daheim
            if spieler(s).schaden > 0 then
              spieler(s).schaden -= 1
              exit select
            end if
            .wert = Arbeiterwert.LaufErnten
          case Arbeiterwert.LaufErnten
            if .x = .zielX and .y = .zielY andalso feld(.zielX, .zielY).fuellAktuell >= SET.Minenfaktor then
              feld(.zielX, .zielY).fuellAktuell -= SET.Minenfaktor
              .warte = 3
              .zielX = spieler(s).hausX
              .zielY = spieler(s).hausY
              .wert = Arbeiterwert.LaufHeim
            end if
          case Arbeiterwert.LaufHeim
            if .x = .zielX and .y = .zielY then
              .warte = 1
              .wert  = Arbeiterwert.LaufErnten
              .zielX = .arbeitX
              .zielY = .arbeitY
              #ifndef STREIK_BEI_SUESSWARENMANGEL
                if opt(spielernr).suess < 0 then
                  .wert = 0
                  this.anzMinenarbeiter -= 1
                  this.anzArbeiter -= 1
                end if
              #endif
              spieler(s).fuellGesamt += 1
              spieler(s).dollar += 1
            end if            
        end select
        #ifdef STREIK_BEI_SUESSWARENMANGEL
          if spieler(s).suess <= 0 then .warte += 1
        #endif
        .weiter
        arbeiter = spieler(s).minenarbeiter.set(i, arbeiter)
      end with
    next
    ' Suessigkeitenjaeger bewegen
    for i as integer = 0 to spieler(s).jaeger.size - 1
      arbeiter = spieler(s).jaeger.get(i)
      with arbeiter
        select case .wert
          case 0 : continue for
          case Arbeiterwert.Daheim
            if spieler(s).schaden > 0 then
              spieler(s).schaden -= 1
              exit select
            end if
            .wert = Arbeiterwert.LaufJagen
          case Arbeiterwert.LaufJagen
            if .x = .zielX and .y = .zielY then
              .warte = 2
              .zielX = spieler(s).hausX
              .zielY = spieler(s).hausY
              if spieler(.gegner).suess >= SET.Jagdbeute then
                .wert = Arbeiterwert.LaufErnten + SET.Jagdbeute
                spieler(.gegner).suess -= SET.Jagdbeute
              else
                dim as integer beute = iif(spieler(.gegner).suess > 0, spieler(.gegner).suess, 0)
                spieler(.gegner).schaden += SET.Jagdbeute - beute
                .wert = Arbeiterwert.LaufErnten + beute
                if beute > 0 then spieler(.gegner).suess = 0
              end if
            end if
          case Arbeiterwert.LaufErnten to Arbeiterwert.LaufErnten + SET.Jagdbeute
            if .x = .zielX and .y = .zielY then
              .warte = 1
              spieler(s).suess += .wert - Arbeiterwert.LaufErnten
              spieler(s).beute += .wert - Arbeiterwert.LaufErnten
              .wert  = Arbeiterwert.LaufJagen
              .zielX = .arbeitX
              .zielY = .arbeitY
              #ifndef STREIK_BEI_SUESSWARENMANGEL
                if spieler(s).suess < 0 then
                  .wert = 0
                  spieler(s).anzJaeger -= 1
                  spieler(s).anzArbeiter -= 1
                end if
              #endif
            end if            
        end select
        #ifdef STREIK_BEI_SUESSWARENMANGEL
          if spieler(s).suess <= 0 then .warte += 1
        #endif
        .weiter
        arbeiter = spieler(s).jaeger.set(i, arbeiter)
      end with
    next
  next
  ' Minen regenerieren
  for i as integer = 0 to ubound(minen)
    let (x, y) = minen(i)
    with feld(x, y)
      .fuellAktuell = iif(.fuellAktuell+.regeneration > .fuellMax, .fuellMax, .fuellAktuell+.regeneration)
    end with
  next
end sub

sub hexfeld(fx as integer, fy as integer, farbe as integer)
  ' zeichnet ein einzelnes Hex
  dim as integer x = SET.HexXplus + fx*SET.HexRadius*3/2 + SET.FeldXPlus
  dim as integer y = SET.HexYplus + (fy + .5*(fx mod 2))*SET.HexGroesse
  line (x, y+SET.HexGroesse\2)-step(SET.HexRadius\2, SET.HexGroesse\2), farbe
  line -step(SET.HexRadius, 0), farbe
  line -step(SET.HexRadius\2, -SET.HexGroesse\2), farbe
  line -step(-SET.HexRadius\2, -SET.HexGroesse\2), farbe
  line -step(-SET.HexRadius, 0), farbe
  line -step(-SET.HexRadius\2, SET.HexGroesse\2), farbe
end sub

sub hexfeld(fx as integer, fy as integer, f as TypFeld)
  ' zeichnet ein einzelnes Hex samt Inhalt
  dim as integer x = SET.HexXplus + fx*SET.HexRadius*3/2 + SET.FeldXPlus
  dim as integer y = SET.HexYplus + (fy + .5*(fx mod 2))*SET.HexGroesse
  dim as integer farbe
  select case f.besitzer
    case 0      : farbe = SET.FarbeHex
    case 1      : farbe = SET.FarbeSpieler
    case 2 to 4 : farbe = SET.FarbeMitspieler
    case 5 to 8 : farbe = SET.FarbeGegner
  end select
  put (x+6, y+6), img(0), pset
  hexfeld fx, fy, farbe
  if f.art <> Feldart.Leer then put (x+6, y+6), img(f.art), trans
end sub

sub info(opt() as TypSpielopt, spielernr as integer)
  ' Anzeige der allgemeinen Spiel-Informationen
  dim as integer x = SET.InfoX, y = SET.InfoY, optwert, nr
  screenlock
  line (x, y)-(SET.FeldXPlus+9, y+SET.InfoHoch), 0, bf
  draw string (x, y), "ALLGEMEINE DATEN"
  line (x, y+8)-step(128, 0)
  y += 30
  for i as integer = 1 to ubound(anzeige)
    if anzeige(i).typ <> "" then
      nr = iif(anzeige(i).nr = -1, spielernr, anzeige(i).nr)
      optwert = opt(nr).opt(anzeige(i).typ)
      draw string (x, y), anzeige(i).text
      if optwert = -1 then
        draw string (x+152, y), "----"
      else
        draw string (x+152, y), rechtsbuendig(optwert, 4)
      end if
    end if
    y += 10
  next
  y += 10
  with opt(spielernr)
    draw string (x, y),    "gesparte Dollar:   "        & rechtsbuendig(.dollar,           4)
    draw string (x, y+10), "S"ue ss"igkeiten:       "   & rechtsbuendig(.suess,            4)
    draw string (x, y+30), "Krieger:           "        & rechtsbuendig(.anzKrieger,       4)
    draw string (x, y+40), !"\237 Gesundheit:      "    & rechtsbuendig(0,                 3) & "%"
    draw string (x, y+70), "Arbeiter (gesamt): "        & rechtsbuendig(.anzArbeiter,      4)
    draw string (x, y+80), "Arbeiter (Felder): "        & rechtsbuendig(.anzFeldarbeiter,  4)
    draw string (x, y+90), "Arbeiter (Minen):  "        & rechtsbuendig(.anzMinenarbeiter, 4)
    draw string (x, y+100), "Arbeiter (J"ae"ger):  "    & rechtsbuendig(.anzJaeger,       4)
    draw string (x, y+130), "S"ue ss"igkeitenfallen: "  & rechtsbuendig(.fallen,           4)
    draw string (x, y+140), "Fallenproduktion: "        & rechtsbuendig(.fallenprod,       4) & "%"
  end with
  screenunlock
end sub

function pruefeButtons(opt as TypSpielopt, anzeige as integer = 0) as integer
  ' prueft in der Steuerleiste, ob ein Button gedrueckt wurde
  dim as integer mx, my, mb, x = SET.SteuerX, y = SET.SteuerY
  getmouse mx, my,, mb
  if mb <> 1 or mx < x or mx > x+SET.Steuerbreit then return 0

  select case anzeige
    case Modus.Haus      ' eigenes Haus angeklickt
      if opt.inaktivFeldarb = 0 and opt.suess >= SET.KostenArbeiter and opt.anzFeldarbeiter < opt.anzGarten/2 then
        if my > y + SET.SteuerFeld and my < y + SET.SteuerFeld + 20 then return Button.Feld
      end if
      if opt.inaktivFalle = 0 and opt.suess >= SET.KostenFalle then
        if my > y + SET.SteuerFalleProd and my < y + SET.SteuerFalleProd + 20 then return Button.FalleProd
      end if
    case Modus.Fremd     ' fremdes Haus angeklickt
      if opt.inaktivJaeger = 0 and opt.suess >= SET.KostenArbeiter then
        if my > y + SET.SteuerJaeger and my < y + SET.SteuerJaeger + 20 then return Button.Jaeger
      end if
    case Modus.Mine      ' Mine angeklickt
      if opt.inaktivMinen = 0 and opt.suess >= SET.KostenArbeiter then
        if my > y + SET.SteuerMine and my < y + SET.SteuerMine + 20 then return Button.Mine
      end if
    case Modus.Feld      ' Feld um das Haus herum angeklickt
      if opt.inaktivKrieger = 0 and opt.dollar >= SET.KostenKrieger then
        if my > y + SET.SteuerKrieger and my < y + SET.SteuerKrieger + 20 then return Button.Krieger
      end if
      if opt.inaktivFeld = 0 and opt.suess >= SET.KostenFeld1 and opt.dollar >= SET.KostenFeld2 then
        if my > y + SET.SteuerGarten and my < y + SET.SteuerGarten + 20 then return Button.Garten
      end if
  end select
  if anzeige and Modus.Einzug then    ' Feld in der Naehe eines Kriegers
    if opt.fallen > 0 then
      if my > y + SET.SteuerFalleSetz and my < y + SET.SteuerFalleSetz + 20 then return Button.FalleSetz
    end if
  end if
end function

function rechtsbuendig(s as string, anz as integer) as string
  ' gibt den String rechtsbuendig zurueck
  if len(s) > anz then return right(s, anz) else return space(anz-len(s)) & s
end function

function rechtsbuendig(i as integer, anz as integer) as string
  ' gibt die Zahl als rechtsbuendigen String zurueck
  return rechtsbuendig(str(i), anz)
end function

function leseOpt cdecl (byval L as lua_State ptr) as long
  dim as integer parameterzahl = lua_gettop(L)
  if parameterzahl < 1 then print "Skriptfehler (set)" : return 0
  dim as integer parameter(0 to parameterzahl-1)
  dim as string typ = lcase(*lua_tostring(L, 1))
  for i as integer = 2 to parameterzahl
    parameter(i-2) = lua_tonumber(L, i)
  next
  lua_pushnumber(L, (spieloptionen+parameter(0))->opt(typ))
  return 1
end function

function setzeInfo cdecl (byval L as lua_State ptr) as long
  dim as integer parameterzahl = lua_gettop(L)
  if parameterzahl < 2 or parameterzahl > 3 then print "Skriptfehler (info)" : return 0
  dim as integer anz = ubound(anzeige)
  if anz < 1 then anz = 1
  if anz > SET.MaxAnzeigen then print "Zu viele Anzeigen angegeben!" : return 0
  dim as string text = left(*lua_tostring(L, 1), 20), typ = *lua_tostring(L, 2)
  dim as integer nr = iif(parameterzahl = 3, lua_tonumber(L, 3), -1)
  redim preserve anzeige(1 to anz+1)
  anzeige(anz+1) = TypAnzeige(typ, text, nr)
  return 0
end function

sub setzeOpt cdecl (byval lua AS lua_State ptr)
  dim as integer parameterzahl, nr, temp, vonX, vonY, nachX, nachY, anz
  dim as Figurart figur
  dim as string typ
  parameterzahl = lua_gettop(lua)
  typ = lcase(*lua_tostring(lua, 1))
  
  ' Parameterzahl ueberpruefen
  select case typ
    case "feldarbeiter", "krieger"
      if parameterzahl < 2 or parameterzahl > 5 then print "Falsche Parameterzahl: " & typ : exit sub
    case "minenarbeiter", "jaeger"
      if parameterzahl < 2 or parameterzahl > 7 then print "Falsche Parameterzahl: " & typ : exit sub
    case "haus", "garten"
      if parameterzahl <> 4 then print "Falsche Parameterzahl: " & typ : exit sub
    case "mine"
      if parameterzahl < 4 or parameterzahl > 6 then print "Falsche Parameterzahl: " & typ : exit sub
    case else
      if parameterzahl <> 3 then print "Falsche Parameterzahl: " & typ : exit sub
  end select
  nr = lua_tonumber(lua, 2)
  if (nr < 0 or nr > 9) and typ <> "mine" then exit sub
  select case typ
    case "feldarbeiter", "minenarbeiter", "jaeger", "krieger"
      ' Figur setzen
      if parameterzahl > 5 then
        vonX = lua_tonumber(lua, 3)
        vonY = lua_tonumber(lua, 4)
        nachX = lua_tonumber(lua, 5)
        nachY = lua_tonumber(lua, 6)
      else
        vonX = (spieloptionen+nr)->hausX
        vonY = (spieloptionen+nr)->hausY
        nachX = lua_tonumber(lua, 3)
        nachY = lua_tonumber(lua, 4)
      end if
      anz = iif(parameterzahl mod 2, lua_tonumber(lua, parameterzahl), 1)
      select case typ
        case "feldarbeiter"  : figur = Figurart.Feld
        case "minenarbeiter" : figur = Figurart.Mine
        case "jaeger"        : figur = Figurart.Jaeger
        case "krieger"       : figur = Figurart.Krieger
      end select
      for i as integer = 1 to anz
        (spieloptionen+nr)->add(figur, vonX, vonY, nachX, nachY)
      next
    case else
      ' andere Parameter setzen
      dim as integer p(3)
      for i as integer = 0 to parameterzahl - 3
        p(i) = lua_tonumber(lua, i+3)
      next
      ' Option setzen
      select case typ
        case "haus"
          if p(0) < 1 or p(0) > SET.feldbreit or p(1) < 1 or p(1) > SET.feldhoch then
            print "Hausposition au"ss"erhalb des Spielfeldes!"
            exit sub
          end if
          (spieloptionen+nr)->hausX = p(0)
          (spieloptionen+nr)->hausY = p(1)
          (spieloptionen+nr)->gartenBerechnen
        case "mine"
          if p(0) < 1 or p(0) > SET.feldbreit or p(1) < 1 or p(1) > SET.feldhoch then
            print "Minenposition au"ss"erhalb des Spielfeldes!"
            exit sub
          end if
          feld(p(0), p(1)) = type<TypFeld>(Feldart.Mine, 0)
          with feld(p(0), p(1))
            .fuellMax     = iif(parameterzahl > 4, p(2), SET.MinenFuellung)*SET.Minenfaktor
            .fuellAktuell = .fuellMax
            .regeneration = iif(parameterzahl > 5, p(3), SET.MinenRegeneration)
          end with
          redim preserve minen(ubound(minen)+1)
          minen(ubound(minen)) = type<TypOrt>(p(0), p(1))
        case "typ" 
          (spieloptionen+nr)->typ = p(0)
          if nr >= spielerzahl then spielerzahl = nr + 1
          if (spieloptionen+nr)->img(0) = 0 then
            dim as FB.Image ptr temp
            for i as integer = 0 to 1
              (spieloptionen+nr)->img(i) = imagecreate(20, 20, 0)
              temp = (spieloptionen+nr)->img(i)
              bload "img" slash "arbeiter" & (i+1) & ".bmp", temp
              for x as integer = 0 to 19
                for y as integer = 0 to 19
                  if (point(x, y, temp) and &hffffff) = 255 then
                    pset temp, (x, y), SET.FarbeFigur(nr, 0)
                  elseif (point(x, y, temp) and &hffffff) = 127 then
                    pset temp, (x, y), SET.FarbeFigur(nr, 1)
                  end if
                next
              next
            next
          end if
        case "garten"
          temp = (spieloptionen+nr)->garten(p(0)).wert
          (spieloptionen+nr)->garten(p(0)).wert = p(1)
          if temp = 0 and p(1) > 0 then (spieloptionen+nr)->anzGarten += 1
          if temp > 0 and p(1) = 0 then (spieloptionen+nr)->anzGarten -= 1
        case else
          (spieloptionen+nr)->opt(typ) = p(0)
      end select
  end select
end sub

sub steuerleiste(opt as TypSpielopt, anzeige as integer = 0)
  ' zeigt die Buttons der Steuerleiste an
  dim as integer x = SET.SteuerX, y = SET.SteuerY, b = SET.SteuerBreit
  screenlock
  line (x, y)-step(b, SET.SteuerHoch), 0, bf

  select case anzeige
    case Modus.Haus      ' eigenes Haus angeklickt
      if opt.inaktivFeldarb or opt.suess < SET.KostenArbeiter _
         or opt.anzFeldarbeiter >= opt.anzGarten/2 then color &h707070 else color &hffffff
      line (x, y+SET.SteuerFeld)-step(b, 20),, b
      line (x+1, y+SET.SteuerFeld+1)-step(b-2, 18),, b
      draw string(x+b\2-4*18, y+SET.SteuerFeld+7), "neuer Feldarbeiter"
      if opt.inaktivFalle or opt.suess < SET.KostenFalle then color &h707070 else color &hffffff
      line (x, y+SET.SteuerFalleProd)-step(b, 20),, b
      line (x+1, y+SET.SteuerFalleProd+1)-step(b-2, 18),, b
      draw string(x+b\2-4*19, y+SET.SteuerFalleProd+7), "Falle produzieren"
    case Modus.Fremd     ' fremdes Haus angeklickt
      if opt.inaktivJaeger or opt.suess < SET.KostenArbeiter then color &h707070 else color &hffffff
      line (x, y+SET.SteuerJaeger)-step(b, 20),, b
      line (x+1, y+SET.SteuerJaeger+1)-step(b-2, 18),, b
      draw string(x+b\2-4*19, y+SET.SteuerJaeger+7), "neuer S"ue ss"warenj"ae"ger"
    case Modus.Mine      ' Mine angeklickt
      if opt.inaktivMinen or opt.suess < SET.KostenArbeiter then color &h707070 else color &hffffff
      line (x, y+SET.SteuerMine)-step(b, 20),, b
      line (x+1, y+SET.SteuerMine+1)-step(b-2, 18),, b
      draw string(x+b\2-4*19, y+SET.SteuerMine+7), "neuer Minenarbeiter"
      draw string(x, y+50), "F"ue"llmenge:    " & feld(opt.markX, opt.markY).fuellAktuell \ SET.Minenfaktor _
                            & "/" & feld(opt.markX, opt.markY).fuellMax \ SET.Minenfaktor, &hffffff
      draw string(x, y+60), "Regeneration: " & feld(opt.markX, opt.markY).regeneration / SET.Minenfaktor, &hffffff
    case Modus.Feld      ' Feld um das Haus herum angeklickt
      if opt.inaktivKrieger or opt.dollar < SET.KostenKrieger then color &h707070 else color &hffffff
      line (x, y+SET.SteuerKrieger)-step(b, 20),, b
      line (x+1, y+SET.SteuerKrieger+1)-step(b-2, 18),, b
      draw string(x+b\2-4*13, y+SET.SteuerKrieger+7), "neuer Krieger"
      if opt.inaktivFeld or opt.suess < SET.KostenFeld1 or opt.dollar < SET.KostenFeld2 _
        or feld(opt.markX, opt.markY).art > 0 then color &h707070 else color &hffffff
      line (x, y+SET.SteuerGarten)-step(b, 20),, b
      line (x+1, y+SET.SteuerGarten+1)-step(b-2, 18),, b
      draw string(x+b\2-4*11, y+SET.SteuerGarten+7), "Feld kaufen"
  end select
  if anzeige and Modus.Einzug then    ' Feld in der Naehe eines Kriegers
    line (x, y+185)-step(b, 20),, b
    line (x+1, y+186)-step(b-2, 18),, b
    draw string(x+b\2-4*17, y+193), "Falle postieren"
  end if

  screenunlock
  color &hffffff
end sub

sub zeichne(opt as TypSpielopt, schrittweite as integer)
  ' zeichnet alle variablen Spielelemente
  if opt.typ = 0 then exit sub
  dim as integer x = opt.hausX, y = opt.hausY - 1
  for i as integer = 1 to 18
    select case as const i
      case 3, 10, 11 : y += 1
      case 6, 16, 17 : y -= 1
      case 7 : if x mod 2 then y -= 1 else y -= 2
      case 2, 4, 8, 9, 12, 13 : if x mod 2 then y += 1
      case 5, 14, 15, 18      : if (x mod 2) = 0 then y -= 1
    end select
    select case as const i
      case 2, 7, 8, 9, 18 : x += 1
      case 4, 5, 12 to 15 : x -= 1
    end select
    if opt.garten(i).wert = 0 then continue for
    if x < 1 or y < 1 or x > SET.FeldBreit or y > SET.FeldHoch then continue for
    if schrittweite = SET.Schrittezahl andalso opt.garten(i).wert > 2 and opt.garten(i).wert < 22 then
      opt.garten(i).wert += 1
    end if
    hexfeld x, y, type<TypFeld>(Feldart.Garten0 + opt.garten(i).wert\4, opt.typ)
  next
  zeichne opt.feldarbeiter, schrittweite
  zeichne opt.minenarbeiter, schrittweite
  zeichne opt.jaeger, schrittweite
  hexfeld opt.hausX, opt.hausY, type<TypFeld>(Feldart.Haus, opt.typ)
  if opt.schaden > 9 then
    put (SET.HexXplus + opt.hausX*SET.HexRadius*3/2 + SET.FeldXPlus, _
        SET.HexYplus + (opt.hausY + .5*(opt.hausX mod 2))*SET.HexGroesse), _
        img(iif(opt.schaden < 100, Feldart.Defekt10+opt.schaden\10-1, Feldart.Defekt100)), add
  end if
  if opt.markX > 0 then hexfeld opt.markX, opt.markY, SET.FarbeMark
end sub

sub zeichne(liste as mdlist(TypFigur), schritt as integer)
  ' zeichnet alle Elemente der angegebenen Liste
  dim as TypFigur arbeiter
  for i as integer = 0 to liste.size
    arbeiter = liste.get(i)
    with arbeiter
      if .wert = 0 then continue for
      dim as integer x1 = SET.HexXplus + .x*SET.HexRadius*3/2 + SET.FeldXPlus + 6
      dim as integer y1 = SET.HexYplus + (.y + .5*(.x mod 2))*SET.HexGroesse + 6
      dim as integer x2 = SET.HexXplus + .neuX*SET.HexRadius*3/2 + SET.FeldXPlus + 6
      dim as integer y2 = SET.HexYplus + (.neuY + .5*(.neuX mod 2))*SET.HexGroesse + 6
      put (x1 + schritt*(x2-x1)\SET.Schrittezahl, y1 + schritt*(y2-y1)\SET.Schrittezahl), .img, trans
    end with
  next
end sub
